// With WIFI
// Work Out Routine1
// Left Leg1
                 //X, Y
int posicion_1[]= {-5, 66}; // Initial Position
int posicion_2[]= {-30, 40}; // Heel kick Position
int posicion_3[]= {0, 68}; // Knee up Position
int posicion_4[]= {30, -4}; // Front kick Position
int posicion_5[]= {7, -1}; // Back kick Position
int posicion_6[]= {77, -2}; // Side Kick Position

int abductor_1[]= {7, -3}; //Abductor Position 1
int abductor_2[]= {10, -2}; //Abductor Position 2

// Lib
#include <WiFi.h>
#include <HTTPClient.h>
#include <Wire.h>
#include <MPU6050.h>
#include "soc/soc.h"
#include "soc/rtc_cntl_reg.h"
MPU6050 sensor;

// Strings for the website
String message="";
String myWebPage="https://alexservernuevo2.000webhostapp.com/"; You can use a webhostapp 
//String myWebPage="http://localhost/"; //Or a local host app as well
String sensorN = "sensor1/"; // Sensor Variable 
String Password = "12345678" ;
String WIFI= "alex" ; 

const int Modulo_vibrador= 17 ; // Declaring GPIO 17 as a vibrator (or buzzer module),
                                // I used the variable for the same thing.

// RAW, unprocessed values of the accelerometer on the X,Y,Z axis.
int ax, ay, az;
int arreglo[]= {0, 0, 0}; // Declaring array

void setup() {//Seting up the data collecting
  const int Modulo_vibrador= 17 ; 
  
  WRITE_PERI_REG(RTC_CNTL_BROWN_OUT_REG, 0); 
    Wire.begin();
    Serial.begin(115200); //Serial necessary to operate the port
    Serial.println();
    Serial.println();
    Serial.println();
    sensor.initialize();

    // Verifying sensor's connection
  if (sensor.testConnection()) { Serial.println("MPU6050 connection successful"); } 
  else { Serial.println("MPU6050 connection failed");
    while (1);
  }
 //waiting protocol 
    for(uint8_t t = 4; t > 0; t--) {
        Serial.printf("[SETUP] WAIT %d...\n", t);
        Serial.flush();
        delay(1000);
    }

    //Conect to wifi network
    WiFi.begin(WIFI, Password);  //Wifi_Network, Wifi_Password ******CHANGE

    //Wait until connection
    while((WiFi.status() != WL_CONNECTED)) {
      delay(500);
      Serial.print(".");
    }
     Serial.println("Wifi conected");
    
}

void loop() {
    // Get the sensors data
    int16_t ax, ay, az, gx, gy, gz;

    sensor.getMotion6(&ax, &ay, &az, &gx, &gy, &gz);

    // Calculating orientation
    float accel_ang_x=atan(ax/sqrt(pow(ay,2) + pow(az,2)))*(180.0/3.14);
    float accel_ang_y=atan(ay/sqrt(pow(ax,2) + pow(az,2)))*(180.0/3.14);

   // accel_ang_x = toInt
    int A= accel_ang_x; 
    int B= accel_ang_y; 
//                                                   reference angles= X, Y
    // Knees to the chest
    rutina(accel_ang_x, accel_ang_y, Modulo_vibrador, posicion_3[0], posicion_3[1]); 
    
    // Front kicks
    //rutina(accel_ang_x, accel_ang_y, Modulo_vibrador, posicion_4[0], posicion_4[1] );
    
    // Heel kick
    //rutina(accel_ang_x, accel_ang_y, Modulo_vibrador, posicion_2[0], posicion_2[1] );
   
    Serial.print("Angle in X: ");
    Serial.println(accel_ang_x);
    Serial.print("  Angle in Y: ");
    Serial.println(accel_ang_y); 

    // wait for WiFi connection
    if((WiFi.status() == WL_CONNECTED)) {

        HTTPClient http;

        Serial.print("[HTTP] begin...\n");
        
        // configure traged server and url
        message=myWebPage+sensorN+"?A="+String(A)+"&B="+String(B);  // Request Message Domain/page/request
        http.begin(message); //HTTP
        Serial.print(message);
        
        // start connection and send HTTP header, return error code
        int httpCode = http.GET();
        Serial.print("[HTTP] GET...\n");
        Serial.printf("[HTTP] GET... code: %d\n", httpCode);
        http.end();
    }

    delay(500);
}

// Movement functions (Buzzer)
void rutina(int angulo_X, int angulo_Y, int vibrador, int ref_X, int ref_Y){ //We set the buzzer's activation parameters according to the angles
  if ((angulo_X > ref_X-10 && angulo_X < ref_X+10) && (angulo_Y > ref_Y-10 && angulo_Y < ref_Y+10)){  //We can eliminate the x angle for now to simplify the data transfer
                                                                                                      //or in case X remains constant
      analogWrite(vibrador, 250); // PIN 7 PWM singal on 75% power. Buzzer on
      delay(200); 
      analogWrite(vibrador, 0); // PIN 7 PWM singal off. Buzzer off
      delay(200); 
  }
  else {
      analogWrite(vibrador, 0);
  }
}
